#pragma once

#define VULKAN_HPP_DISPATCH_LOADER_DYNAMIC 1 // Use dynamic dispatch for Vulkan functions
#define VULKAN_HPP_NO_CONSTRUCTORS
#include <vulkan/vulkan.hpp>

#include "../util/types.hpp"

class DebugMessenger {
 public:
  DebugMessenger()                                     = default;
  DebugMessenger(const DebugMessenger&)                = default;
  DebugMessenger(DebugMessenger&&)                     = delete;
  fn operator=(const DebugMessenger&)->DebugMessenger& = default;
  fn operator=(DebugMessenger&&)->DebugMessenger&      = delete;
  ~DebugMessenger()                                    = default;

  static fn create(const vk::Instance& instance) -> vk::UniqueDebugUtilsMessengerEXT;

 private:
  static VKAPI_ATTR VkBool32 VKAPI_CALL debugCallback(
    VkDebugUtilsMessageSeverityFlagBitsEXT      messageSeverity,
    VkDebugUtilsMessageTypeFlagsEXT             messageType,
    const VkDebugUtilsMessengerCallbackDataEXT* pCallbackData,
    void*                                       pUserData
  );
};
