#pragma once

#include <vector>
#include <vulkan/vulkan.hpp>

/**
 * @brief Struct to hold swap chain support details.
 *
 * This struct contains information about the surface capabilities,
 * supported formats, and presentation modes.
 */
struct SwapChainSupportDetails {
    vk::SurfaceCapabilitiesKHR        capabilities;  ///< Surface capabilities
    std::vector<vk::SurfaceFormatKHR> formats;       ///< Supported surface formats
    std::vector<vk::PresentModeKHR>   present_modes; ///< Supported presentation modes
};
